Package org.springframework.aop.interceptor

# Class AbstractTraceInterceptor

java.lang.Object
org.springframework.aop.interceptor.AbstractTraceInterceptor

All Implemented Interfaces:
  `Serializable`, `Advice`, `Interceptor`, `MethodInterceptor`

Direct Known Subclasses:
  `AbstractMonitoringInterceptor`, `CustomizableTraceInterceptor`, `SimpleTraceInterceptor`

public abstract class AbstractTraceInterceptor extends Object implements MethodInterceptor, Serializable
Base `MethodInterceptor` implementation for tracing.

By default, log messages are written to the log for the interceptor class, not the class which is being intercepted. Setting the `useDynamicLogger` bean property to `true` causes all log messages to be written to the `Log` for the target class being intercepted.

Subclasses must implement the `invokeUnderTrace` method, which is invoked by this class ONLY when a particular invocation SHOULD be traced. Subclasses should write to the `Log` instance provided.

Since:
  1.2
Author:
  Rob Harrop, Juergen Hoeller
See Also:
  - `setUseDynamicLogger(boolean)`
  - `invokeUnderTrace(org.aopalliance.intercept.MethodInvocation, org.apache.commons.logging.Log)`
  - Serialized Form

## Field Summary

Fields
Modifier and Type
Field
Description
`protected org.apache.commons.logging.Log`
`defaultLogger`
The default `Log` instance used to write trace messages.

## Constructor Summary

Constructors
Constructor
Description
`AbstractTraceInterceptor()`

## Method Summary

Modifier and Type
Method
Description
`protected Class<?>`
`getClassForLogging(Object target)`
Determine the class to use for logging purposes.
`protected org.apache.commons.logging.Log`
`getLoggerForInvocation(MethodInvocation invocation)`
Return the appropriate `Log` instance to use for the given `MethodInvocation`.
`Object`
`invoke(MethodInvocation invocation)`
Determines whether logging is enabled for the particular `MethodInvocation`.
`protected abstract Object`
`invokeUnderTrace(MethodInvocation invocation, org.apache.commons.logging.Log logger)`
Subclasses must override this method to perform any tracing around the supplied `MethodInvocation`.
`protected boolean`
`isInterceptorEnabled(MethodInvocation invocation, org.apache.commons.logging.Log logger)`
Determine whether the interceptor should kick in, that is, whether the `invokeUnderTrace` method should be called.
`protected boolean`
`isLogEnabled(org.apache.commons.logging.Log logger)`
Determine whether the given `Log` instance is enabled.
`void`
`setHideProxyClassNames(boolean hideProxyClassNames)`
Set to "true" to have `dynamic loggers` hide proxy class names wherever possible.
`void`
`setLogExceptionStackTrace(boolean logExceptionStackTrace)`
Set whether to pass an exception to the logger, suggesting inclusion of its stack trace into the log.
`void`
`setLoggerName(String loggerName)`
Set the name of the logger to use.
`void`
`setUseDynamicLogger(boolean useDynamicLogger)`
Set whether to use a dynamic logger or a static logger.
`protected void`
`writeToLog(org.apache.commons.logging.Log logger, String message)`
Write the supplied trace message to the supplied `Log` instance.
`protected void`
`writeToLog(org.apache.commons.logging.Log logger, String message, Throwable ex)`
Write the supplied trace message and `Throwable` to the supplied `Log` instance.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### defaultLogger

@Nullable protected transient org.apache.commons.logging.Log defaultLogger
The default `Log` instance used to write trace messages. This instance is mapped to the implementing `Class`.

## Constructor Details

### AbstractTraceInterceptor

public AbstractTraceInterceptor()

## Method Details

### setUseDynamicLogger

public void setUseDynamicLogger(boolean useDynamicLogger)
Set whether to use a dynamic logger or a static logger. Default is a static logger for this trace interceptor.

Used to determine which `Log` instance should be used to write log messages for a particular method invocation: a dynamic one for the `Class` getting called, or a static one for the `Class` of the trace interceptor.

NOTE: Specify either this property or "loggerName", not both.

See Also:
  - `getLoggerForInvocation(org.aopalliance.intercept.MethodInvocation)`

### setLoggerName

public void setLoggerName(String loggerName)
Set the name of the logger to use. The name will be passed to the underlying logger implementation through Commons Logging, getting interpreted as log category according to the logger's configuration.

This can be specified to not log into the category of a class (whether this interceptor's class or the class getting called) but rather into a specific named category.

NOTE: Specify either this property or "useDynamicLogger", not both.

See Also:
  - `LogFactory.getLog(String)`
  - `Logger.getLogger(String)`

### setHideProxyClassNames

public void setHideProxyClassNames(boolean hideProxyClassNames)
Set to "true" to have `dynamic loggers` hide proxy class names wherever possible. Default is "false".

### setLogExceptionStackTrace

public void setLogExceptionStackTrace(boolean logExceptionStackTrace)
Set whether to pass an exception to the logger, suggesting inclusion of its stack trace into the log. Default is "true"; set this to "false" in order to reduce the log output to just the trace message (which may include the exception class name and exception message, if applicable).

Since:
  4.3.10

### invoke

@Nullable public Object invoke(MethodInvocation invocation) throws Throwable
Determines whether logging is enabled for the particular `MethodInvocation`. If not, the method invocation proceeds as normal, otherwise the method invocation is passed to the `invokeUnderTrace` method for handling.

Specified by:
  `invoke` in interface `MethodInterceptor`
Parameters:
  `invocation` - the method invocation joinpoint
Returns:
  the result of the call to `Joinpoint.proceed()`; might be intercepted by the interceptor
Throws:
  `Throwable` - if the interceptors or the target object throws an exception
See Also:
  - `invokeUnderTrace(org.aopalliance.intercept.MethodInvocation, org.apache.commons.logging.Log)`

### getLoggerForInvocation

protected org.apache.commons.logging.Log getLoggerForInvocation(MethodInvocation invocation)
Return the appropriate `Log` instance to use for the given `MethodInvocation`. If the `useDynamicLogger` flag is set, the `Log` instance will be for the target class of the `MethodInvocation`, otherwise the `Log` will be the default static logger.

Parameters:
  `invocation` - the `MethodInvocation` being traced
Returns:
  the `Log` instance to use
See Also:
  - `setUseDynamicLogger(boolean)`

### getClassForLogging

protected Class<?> getClassForLogging(Object target)
Determine the class to use for logging purposes.

Parameters:
  `target` - the target object to introspect
Returns:
  the target class for the given object
See Also:
  - `setHideProxyClassNames(boolean)`

### isInterceptorEnabled

protected boolean isInterceptorEnabled(MethodInvocation invocation, org.apache.commons.logging.Log logger)
Determine whether the interceptor should kick in, that is, whether the `invokeUnderTrace` method should be called.

Default behavior is to check whether the given `Log` instance is enabled. Subclasses can override this to apply the interceptor in other cases as well.

Parameters:
  `invocation` - the `MethodInvocation` being traced
  `logger` - the `Log` instance to check
See Also:
  - `invokeUnderTrace(org.aopalliance.intercept.MethodInvocation, org.apache.commons.logging.Log)`
  - `isLogEnabled(org.apache.commons.logging.Log)`

### isLogEnabled

protected boolean isLogEnabled(org.apache.commons.logging.Log logger)
Determine whether the given `Log` instance is enabled.

Default is `true` when the "trace" level is enabled. Subclasses can override this to change the level under which 'tracing' occurs.

Parameters:
  `logger` - the `Log` instance to check

### writeToLog

protected void writeToLog(org.apache.commons.logging.Log logger, String message)
Write the supplied trace message to the supplied `Log` instance.

To be called by `invokeUnderTrace(org.aopalliance.intercept.MethodInvocation, org.apache.commons.logging.Log)` for enter/exit messages.

Delegates to `writeToLog(Log, String, Throwable)` as the ultimate delegate that controls the underlying logger invocation.

Since:
  4.3.10
See Also:
  - `writeToLog(Log, String, Throwable)`

### writeToLog

protected void writeToLog(org.apache.commons.logging.Log logger, String message, @Nullable Throwable ex)
Write the supplied trace message and `Throwable` to the supplied `Log` instance.

To be called by `invokeUnderTrace(org.aopalliance.intercept.MethodInvocation, org.apache.commons.logging.Log)` for enter/exit outcomes, potentially including an exception. Note that an exception's stack trace won't get logged when `setLogExceptionStackTrace(boolean)` is "false".

By default messages are written at `TRACE` level. Subclasses can override this method to control which level the message is written at, typically also overriding `isLogEnabled(org.apache.commons.logging.Log)` accordingly.

Since:
  4.3.10
See Also:
  - `setLogExceptionStackTrace(boolean)`
  - `isLogEnabled(org.apache.commons.logging.Log)`

### invokeUnderTrace

@Nullable protected abstract Object invokeUnderTrace(MethodInvocation invocation, org.apache.commons.logging.Log logger) throws Throwable
Subclasses must override this method to perform any tracing around the supplied `MethodInvocation`. Subclasses are responsible for ensuring that the `MethodInvocation` actually executes by calling `MethodInvocation.proceed()`.

By default, the passed-in `Log` instance will have log level "trace" enabled. Subclasses do not have to check for this again, unless they overwrite the `isInterceptorEnabled` method to modify the default behavior, and may delegate to `writeToLog` for actual messages to be written.

Parameters:
  `logger` - the `Log` to write trace messages to
Returns:
  the result of the call to `MethodInvocation.proceed()`
Throws:
  `Throwable` - if the call to `MethodInvocation.proceed()` encountered any errors
See Also:
  - `isLogEnabled(org.apache.commons.logging.Log)`
  - `writeToLog(Log, String)`
  - `writeToLog(Log, String, Throwable)`